CHOOM(1)

BEZEICHNUNG
choom - Bewertungen des OOM-Killers anzeigen oder anpassen

ÜBERSICHT

choom -p PID

choom -p PID -n Zahl

choom -n Zahl [--] Befehl [Argument ...]

BESCHREIBUNG

Der Befehl choom zeigt oder passt die Bewertungseinstellungen des Speicherknappheit-Killers an.

OPTIONEN

-p, --pid PID
    gibt die Prozesskennung an.

-n, --adjust Wert
    gibt die Anpassungsbewertung an.

-h, --help
    zeigt einen Hilfetext an und beendet das Programm.

-V, --version
    zeigt Versionsinformationen an und beendet das Programm.

ANMERKUNGEN

Der Linux-Kernel verwendet die Schlechtigkeits-Heuristik, um auszuwählen, welcher Prozess getötet werden soll, wenn der Speicher ausgeschöpft ist.

Die Schlechtigkeits-Heuristik weist jedem möglichen Prozess einen Wert von 0 (niemals töten) bis 1000 (immer töten) zu, um zu bestimmen, welcher Prozess infrage kommt. Der Wert beschreibt im Wesentlichen den kontinuierlichen Anteil des erlaubten Speichers, aus dem sich der Prozess Speicher zuweisen darf. Als Grundlage dient dazu der aktuelle verwendete Speicher und Auslagerungsspeicher. Wenn ein Prozess beispielsweise sämtlichen erlaubten Speicher nutzt, ist dessen Schlechtigkeitsbewertung bei 1000. Nutzt er die Hälfte des erlaubten Speichers, beträgt die Bewertung 500.

Es gibt einen weiteren Faktor in der Schlechtigkeitsbewertung: Die aktuelle Speicher- und Auslagerungsspeichernutzung wird für Root-Prozesse um 3% zurückgesetzt.

Die Menge des »erlaubten« Speichers hängt von dem Kontext ab, in dem der OOM-Killer aufgerufen wurde. Falls der Kontext ist, dass der oder die Prozessoren ausgelastet sind, entspricht der erlaubte Speicher dem Speicher, der diesem Cpuset zugewiesen ist. Falls der oder die Mempolicy-Knoten erschöpft ist/sind, repräsentiert der erlaubte Speicher die Mempolicy-Knoten. Falls eine Arbeitsspeicher- (oder Auslagerungsspeicher-) Grenze erreicht wurde, entspricht der erlaubte Speicher dieser Grenze. Sollte das gesamte System keinen Speicher mehr übrig haben, steht der erlaubte Speicher für alle verfügbaren Ressourcen.

Die Anpassungsbewertung wird zum Schlechtigkeitswert hinzugefügt, bevor dieser zur Ermittlung des zu tötenden Prozesses verwendet wird. Zulässige Werte liegen zwischen -1000 und +1000, einschließlich dieser. Dies ermöglicht auf Anwendungsebene die Polarisierung der Bevorzugung für das OOM-Töten entweder durch permanentes Bevorzugen eines bestimmten Prozesses oder deren vollständige Deaktivierung. Der niedrigste mögliche Wert von -1000 ist gleichbedeutend mit der vollständigen Deaktivierung des OOM-Tötens für diesen Prozess, da diese stets einen Schlechtigkeitswert von 0 meldet.

Die Festlegung eines Anpassungswerts von +500 ist beispielsweise etwa gleichbedeutend damit, dass die übrigen Prozesse, die das gleiche System, Cpuset, Mempolicy oder Speicher-Controller-Ressource mit verwenden, mindestens 50% mehr Speicher verwenden. Andererseits wäre ein Wert von -500 etwa gleichbedeutend damit, den erlaubten Speicher eines Prozesses bei der Bewertung des erlaubten Speichers des Prozesses um 50% zu reduzieren.

AUTOREN

SIEHE AUCH

proc(5)

FEHLER MELDEN

Nutzen Sie zum Melden von Fehlern das

VERFÜGBARKEIT

Der Befehl choom ist Teil des Pakets util-linux, welches aus dem heruntergeladen werden kann.